/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.cosmodas.EntCosmos;

import java.io.Serializable;
import java.util.Collection;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
//import org.codehaus.jackson.annotate.JsonIgnore;

/**
 * @author obper
 */
@Entity
@Table(name = "compras")
@XmlRootElement
@NamedQueries({
        @NamedQuery(name = "Compras.findAll", query = "SELECT c FROM Compras c"),
        @NamedQuery(name = "Compras.findByCompraCodigo", query = "SELECT c FROM Compras c WHERE c.compraCodigo = :compraCodigo"),
        @NamedQuery(name = "Compras.findByCompraFecha", query = "SELECT c FROM Compras c WHERE c.compraFecha = :compraFecha"),
        @NamedQuery(name = "Compras.findByProgramaCodigo", query = "SELECT c FROM Compras c WHERE c.programaCodigo = :programaCodigo"),
        @NamedQuery(name = "Compras.findByUsuarioCodigo", query = "SELECT c FROM Compras c WHERE c.usuarioCodigo = :usuarioCodigo"),
        @NamedQuery(name = "Compras.findByConceptoCompra", query = "SELECT c FROM Compras c WHERE c.conceptoCompra = :conceptoCompra")})
public class Compras implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 5)
    @Column(name = "compra_codigo")
    private String compraCodigo;
    @Basic(optional = false)
    @NotNull
    @Column(name = "compra_fecha")
    @Temporal(TemporalType.TIMESTAMP)
    private Date compraFecha;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 3)
    @Column(name = "programa_codigo")
    private String programaCodigo;
    @Size(max = 3)
    @Column(name = "usuario_codigo")
    private String usuarioCodigo;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 100)
    @Column(name = "concepto_compra")
    private String conceptoCompra;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "compras")
    private Collection<DetalleCompra> detalleCompraCollection;

    public Compras() {
    }

    public Compras(String compraCodigo) {
        this.compraCodigo = compraCodigo;
    }

    public Compras(String compraCodigo, Date compraFecha, String programaCodigo, String conceptoCompra) {
        this.compraCodigo = compraCodigo;
        this.compraFecha = compraFecha;
        this.programaCodigo = programaCodigo;
        this.conceptoCompra = conceptoCompra;
    }

    public String getCompraCodigo() {
        return compraCodigo;
    }

    public void setCompraCodigo(String compraCodigo) {
        this.compraCodigo = compraCodigo;
    }

    public Date getCompraFecha() {
        return compraFecha;
    }

    public void setCompraFecha(Date compraFecha) {
        this.compraFecha = compraFecha;
    }

    public String getProgramaCodigo() {
        return programaCodigo;
    }

    public void setProgramaCodigo(String programaCodigo) {
        this.programaCodigo = programaCodigo;
    }

    public String getUsuarioCodigo() {
        return usuarioCodigo;
    }

    public void setUsuarioCodigo(String usuarioCodigo) {
        this.usuarioCodigo = usuarioCodigo;
    }

    public String getConceptoCompra() {
        return conceptoCompra;
    }

    public void setConceptoCompra(String conceptoCompra) {
        this.conceptoCompra = conceptoCompra;
    }

    @XmlTransient
    //@JsonIgnore
    public Collection<DetalleCompra> getDetalleCompraCollection() {
        return detalleCompraCollection;
    }

    public void setDetalleCompraCollection(Collection<DetalleCompra> detalleCompraCollection) {
        this.detalleCompraCollection = detalleCompraCollection;
    }

//    @Override
//    public int hashCode() {
//        int hash = 0;
//        hash += (compraCodigo != null ? compraCodigo.hashCode() : 0);
//        return hash;
//    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Compras)) {
            return false;
        }
        Compras other = (Compras) object;
        if ((this.compraCodigo == null && other.compraCodigo != null) || (this.compraCodigo != null && !this.compraCodigo.equals(other.compraCodigo))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.cosmodas.dbcon.Compras[ compraCodigo=" + compraCodigo + " ]";
    }

}
